diff --git a/lib/ext/Diff.cabal b/lib/ext/Diff.cabal
index 942bdcb..fb700c6 100644
--- a/lib/ext/Diff.cabal
+++ b/lib/ext/Diff.cabal
@@ -1,5 +1,5 @@
 name:                Diff
-version:             0.1.2
+version:             0.2.0
 synopsis:            O(ND) diff algorithm in haskell.
 description:         Basic implementation of the standard diff algorithm.
 exposed-modules:   Data.Algorithm.Diff
diff --git a/lib/ext/HUnit.cabal b/lib/ext/HUnit.cabal
index 2c84c0a..9c331c6 100644
--- a/lib/ext/HUnit.cabal
+++ b/lib/ext/HUnit.cabal
@@ -1,5 +1,5 @@
 Name:                   HUnit
-Version:                1.2.2.1
+Version:                1.2.5.1
 options:                -fcpp
 Homepage:               http://hunit.sourceforge.net/
 Category:               Testing
@@ -8,6 +8,7 @@ Description:
     HUnit is a unit testing framework for Haskell, inspired by the
     JUnit tool for Java, see: <http://www.junit.org>.
 
+Build-Depends: deepseq
 Exposed-Modules: Test.HUnit.Base,
         Test.HUnit.Lang,
         Test.HUnit.Terminal,
diff --git a/lib/ext/QuickCheck.cabal b/lib/ext/QuickCheck.cabal
index a808b5a..b9e80da 100644
--- a/lib/ext/QuickCheck.cabal
+++ b/lib/ext/QuickCheck.cabal
@@ -1,5 +1,5 @@
 name:		QuickCheck
-version:	1.2.0.0
+version:	1.2.0.1
 license:	BSD3
 license-file:	LICENSE
 options:   -fcpp
diff --git a/lib/ext/deepseq.cabal b/lib/ext/deepseq.cabal
index 29c97a2..b2477b4 100644
--- a/lib/ext/deepseq.cabal
+++ b/lib/ext/deepseq.cabal
@@ -1,11 +1,11 @@
 name:		deepseq
-version:	1.1.0.2
+version:	1.2.0.1
 license:	BSD3
 license-file:	LICENSE
 maintainer:	libraries@haskell.org
 synopsis:	Deep evaluation of data structures
 category:       Control
-options:  -pcontainers
+options:  -pcontainers -fcpp
 description:
     This package provides methods for fully evaluating data structures
     (\"deep evaluation\"). Deep evaluation is often used for adding
diff --git a/lib/ext/filepath.cabal b/lib/ext/filepath.cabal
index e3ee326..0150099 100644
--- a/lib/ext/filepath.cabal
+++ b/lib/ext/filepath.cabal
@@ -1,5 +1,5 @@
 Name:           filepath
-Version:        1.2.0.0
+Version:        1.3.0.1
 License:        BSD3
 license-file:   LICENSE
 Author:         Neil Mitchell
diff --git a/lib/ext/pretty.cabal b/lib/ext/pretty.cabal
index 6e15592..3c8ef2d 100644
--- a/lib/ext/pretty.cabal
+++ b/lib/ext/pretty.cabal
@@ -1,7 +1,8 @@
 name:		pretty
-version:	1.0.1.1
+version:	1.0.1.2
 synopsis:	Pretty-printing library
 category:       Text
+options:        -fcpp
 description:
 	This package contains John Hughes's pretty-printing library,
         heavily modified by Simon Peyton Jones.
diff --git a/lib/ext/safe.cabal b/lib/ext/safe.cabal
index a8c6165..e952fa3 100644
--- a/lib/ext/safe.cabal
+++ b/lib/ext/safe.cabal
@@ -1,13 +1,13 @@
 Name:           safe
 Build-Type:     Simple
-Version:        0.2
+Version:        0.3.3
 License:        BSD3
 License-File:   LICENSE
 Copyright:      2007-8, Neil Mitchell
 Maintainer:     ndmitchell@gmail.com
 Author:         Neil Mitchell
 Homepage:       http://www-users.cs.york.ac.uk/~ndm/safe/
-Build-Depends:  haskell-extras
+Build-Depends:  haskell-extras, applicative
 Category:       Unclassified
 Synopsis:       Library for safe (pattern match free) functions
 Description:
@@ -19,3 +19,4 @@ Description:
     your code.
 Exposed-modules:
         Safe
+        Safe.Foldable
diff --git a/lib/ext/smallcheck.cabal b/lib/ext/smallcheck.cabal
index 7d787da..1178250 100644
--- a/lib/ext/smallcheck.cabal
+++ b/lib/ext/smallcheck.cabal
@@ -1,5 +1,5 @@
 Name:          smallcheck
-Version:       0.4
+Version:       0.6.1
 Author:        Colin Runciman
 Synopsis:      Another lightweight testing library in Haskell.
 Description:   SmallCheck is similar to QuickCheck (Claessen and Hughes 2000-) but
@@ -7,5 +7,5 @@ Description:   SmallCheck is similar to QuickCheck (Claessen and Hughes 2000-) b
                tests properties for all the finitely many values up to some depth,
                progressively increasing the depth used.
 
-Build-Depends: haskell98
+Build-Depends: haskell98, haskell-extras
 Exposed-modules:    Test.SmallCheck
diff --git a/lib/ext/smallcheck.patch b/lib/ext/smallcheck.patch
deleted file mode 100644
index df6129f..0000000
--- a/lib/ext/smallcheck.patch
+++ /dev/null
@@ -1,10 +0,0 @@
-diff -ru smallcheck-0.4/Test/SmallCheck.hs smallcheck-0.4-new/Test/SmallCheck.hs
---- smallcheck-0.4/Test/SmallCheck.hs	2008-05-23 07:04:15.000000000 -0700
-+++ smallcheck-0.4-new/Test/SmallCheck.hs	2010-07-21 15:59:11.000000000 -0700
-@@ -428,5 +428,5 @@
- progressReport i n x | n >= x = do
-   when i $ ( putStr (n' ++ replicate (length n') '\b') >>
-              hFlush stdout )
--  where
-+ where
-   n' = show n
diff --git a/lib/ext/xhtml.cabal b/lib/ext/xhtml.cabal
index 950b88d..9076568 100644
--- a/lib/ext/xhtml.cabal
+++ b/lib/ext/xhtml.cabal
@@ -1,12 +1,13 @@
 Name: xhtml
-Version: 3000.2.0.1
+Version: 3000.2.1
 Copyright: Bjorn Bringert 2004-2006, Andy Gill, and the Oregon Graduate
            Institute of Science and Technology, 1999-2001
 Maintainer: bjorn@bringert.net
 Author: Bjorn Bringert
 License: BSD3
 License-file: LICENSE
-Extensions:
+Options: -fcpp
+Extensions: CPP
 Synopsis: An XHTML combinator library
 Description:
  This package provides combinators for producing
diff --git a/library_deps.make b/library_deps.make
index f76b296..78c48f5 100644
--- a/library_deps.make
+++ b/library_deps.make
@@ -45,34 +45,33 @@ JHC_LIBS = jhc-prim-1.0.hl jhc-1.0.hl haskell-extras-0.8.1.hl haskell2010-0.8.1.
 containers-0.3.0.0.hl: lib/ext/containers.cabal haskell-extras-0.8.1.hl jhc-prim-1.0.hl jhc-1.0.hl applicative-1.0.hl \
     lib/ext/containers.patch
 	perl utils/build_extlibs.prl $<
-Diff-0.1.2.hl: lib/ext/Diff.cabal haskell-extras-0.8.1.hl jhc-prim-1.0.hl jhc-1.0.hl
+Diff-0.2.0.hl: lib/ext/Diff.cabal haskell-extras-0.8.1.hl jhc-prim-1.0.hl jhc-1.0.hl
 	perl utils/build_extlibs.prl $<
 html-1.0.1.2.hl: lib/ext/html.cabal haskell-extras-0.8.1.hl jhc-prim-1.0.hl jhc-1.0.hl
 	perl utils/build_extlibs.prl $<
-HUnit-1.2.2.1.hl: lib/ext/HUnit.cabal haskell-extras-0.8.1.hl jhc-prim-1.0.hl jhc-1.0.hl
+HUnit-1.2.5.1.hl: lib/ext/HUnit.cabal haskell-extras-0.8.1.hl jhc-prim-1.0.hl jhc-1.0.hl deepseq-1.2.0.1.hl
 	perl utils/build_extlibs.prl $<
 parsec-2.1.0.1.hl: lib/ext/parsec.cabal haskell-extras-0.8.1.hl jhc-prim-1.0.hl jhc-1.0.hl
 	perl utils/build_extlibs.prl $<
-pretty-1.0.1.1.hl: lib/ext/pretty.cabal haskell-extras-0.8.1.hl jhc-prim-1.0.hl jhc-1.0.hl
+pretty-1.0.1.2.hl: lib/ext/pretty.cabal haskell-extras-0.8.1.hl jhc-prim-1.0.hl jhc-1.0.hl
 	perl utils/build_extlibs.prl $<
-QuickCheck-1.2.0.0.hl: lib/ext/QuickCheck.cabal haskell-extras-0.8.1.hl jhc-prim-1.0.hl jhc-1.0.hl
+QuickCheck-1.2.0.1.hl: lib/ext/QuickCheck.cabal haskell-extras-0.8.1.hl jhc-prim-1.0.hl jhc-1.0.hl
 	perl utils/build_extlibs.prl $<
-safe-0.2.hl: lib/ext/safe.cabal haskell-extras-0.8.1.hl jhc-prim-1.0.hl jhc-1.0.hl
+safe-0.3.3.hl: lib/ext/safe.cabal haskell-extras-0.8.1.hl jhc-prim-1.0.hl jhc-1.0.hl
 	perl utils/build_extlibs.prl $<
-smallcheck-0.4.hl: lib/ext/smallcheck.cabal haskell-extras-0.8.1.hl haskell98-1.0.hl jhc-prim-1.0.hl jhc-1.0.hl \
-    lib/ext/smallcheck.patch
+smallcheck-0.6.1.hl: lib/ext/smallcheck.cabal haskell-extras-0.8.1.hl haskell98-1.0.hl jhc-prim-1.0.hl jhc-1.0.hl
 	perl utils/build_extlibs.prl $<
-xhtml-3000.2.0.1.hl: lib/ext/xhtml.cabal haskell-extras-0.8.1.hl jhc-prim-1.0.hl jhc-1.0.hl
+xhtml-3000.2.1.hl: lib/ext/xhtml.cabal haskell-extras-0.8.1.hl jhc-prim-1.0.hl jhc-1.0.hl
 	perl utils/build_extlibs.prl $<
 transformers-0.2.1.0.hl: lib/ext/transformers.cabal haskell-extras-0.8.1.hl jhc-prim-1.0.hl jhc-1.0.hl applicative-1.0.hl
 	perl utils/build_extlibs.prl $<
-filepath-1.2.0.0.hl: lib/ext/filepath.cabal haskell-extras-0.8.1.hl jhc-prim-1.0.hl jhc-1.0.hl
+filepath-1.3.0.1.hl: lib/ext/filepath.cabal haskell-extras-0.8.1.hl jhc-prim-1.0.hl jhc-1.0.hl
 	perl utils/build_extlibs.prl $<
-deepseq-1.1.0.2.hl: lib/ext/deepseq.cabal haskell-extras-0.8.1.hl jhc-prim-1.0.hl jhc-1.0.hl containers-0.3.0.0.hl \
+deepseq-1.2.0.1.hl: lib/ext/deepseq.cabal haskell-extras-0.8.1.hl jhc-prim-1.0.hl jhc-1.0.hl containers-0.3.0.0.hl \
     applicative-1.0.hl
 	perl utils/build_extlibs.prl $<
 bytestring-0.9.2.0.hl: lib/ext/bytestring.yaml haskell-extras-0.8.1.hl jhc-prim-1.0.hl jhc-1.0.hl lib/ext/bytestring.patch
 	perl utils/build_extlibs.prl $<
-JHC_EXT_LIBS = containers-0.3.0.0.hl Diff-0.1.2.hl html-1.0.1.2.hl HUnit-1.2.2.1.hl parsec-2.1.0.1.hl \
-    pretty-1.0.1.1.hl QuickCheck-1.2.0.0.hl safe-0.2.hl smallcheck-0.4.hl xhtml-3000.2.0.1.hl \
-    transformers-0.2.1.0.hl filepath-1.2.0.0.hl deepseq-1.1.0.2.hl 
+JHC_EXT_LIBS = containers-0.3.0.0.hl Diff-0.2.0.hl html-1.0.1.2.hl HUnit-1.2.5.1.hl parsec-2.1.0.1.hl \
+    pretty-1.0.1.2.hl QuickCheck-1.2.0.1.hl safe-0.3.3.hl smallcheck-0.6.1.hl xhtml-3000.2.1.hl \
+    transformers-0.2.1.0.hl filepath-1.3.0.1.hl deepseq-1.2.0.1.hl